//NIKOY KWN/NOS 66/96 September '99
//Ergasia: Hashing Visualisation (Linear Probing-Double Hashing)
// 'Algorithms in C,' Sedgewick, Chapter 16

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

 int n,m,d,table[17],Thash1[17],Thash2[17];
 char ch;
 //O pinakas 'table' einai boh0htikos gia thn topo0ethsh twn random ari0mwn
 //meta to hashing.
 //O Thash1 einai to apotelesma toso meta to Linear Probing oso kai
 //to Double Hashing-sthn prwth fash- enw o Thash2 meta thn deuterh fash
 //tou Double Hashing.
 //To 'n' einai o ari0mos twn kleidiwn pou exoume gia topo0ethsh,
 //enw to 'm' einai o ari0mos twn 0esewn pou exoyme dia0esimes sthn mnhmh
 //gia ta kleidia auta. Profanws prepei na isxyei M>N.

 int hash1(int key)
 //For Double Hashing AND Linear Probing
 //Paragei thn timh tou kleidiou-key meta to hashing
 {
  return (key % m);
 }

 int hash2(int key)
 //For Double Hashing
 //Paragei thn timh tou kleidiou-key meta to deutero hashing
 {
  int temp;
  temp=8-(key % 8);
  return temp;
 }

 void Dinsert(int key)
 //For Double Hashing. Synarthsh eisagwghs twn kleidiwn ston pinaka kata
 //to Double Hashing.
 {
  int count,location;

  location=hash1(key);
  if ( table[location] == 0 )
    {
      table[location]=key;
      Thash1[location]=location;
      Thash2[location]=99; //Sthn periptwsh pou to kleidi-key
     //brei amesws 0esh ston pinaka, h timh tou deuterou hashing gia to kleidi
     //auto einai 99
     }
   else
    {
     printf("* COLL *- ");    //Edw exoume COLLISION, to kleidi mpainei
			      //arxika sthn 0esh pou 'sygrouetai' me ton allo
			      //ari0mo, enw sto epomeno bhma mpainei sth 0esh
			      //meta to hashing
     for (d=0;d<location;d++) printf(" -- ",0);
     printf(" %2d ",key);
     for (d=location+1;d<m;d++) printf(" -- ",0);
     printf("\n");ch=getch();
     count=0;
     do {
       count++;
       location=(location+hash2(key))%m;
       if (count==20) {printf("\n\n**Adynamia topo8ethshs!!!!**\n\n"); break; }
				    //Edw exoume thn periptwsh opou ena kleidi
				    //den mporei na brei dia0esimh 0esh na
				    //topo0eth0ei ston pinaka meta to hashing.
				    //Ousiastika peftei synexeia stis idies 0eseis(infinite loop)
     } while (table[location]!=0);
    table[location]=key;
    Thash1[location]=hash1(key);
    Thash2[location]=hash2(key);
    }
 }

int Linsert(int key)
//For Linear Probing.Synarthsh eisagwghs twn kleidiwn ston pinaka kata
 //to Linear Probing.
{
 int done,count,location;

 done=1; location=hash1(key);
 if ( table[location] == 0 )
   table[location]=key;  //An to kleidi exei timh-hash pou antistoixei se
			 //adeia 0esh katalambanei th 0esh auth.
  else
   {
    printf("* COLL *- "); //An exei COLLISION emfanizei th 0esh opou ginetai
			  //auto, enw sto epomeno bhma topo0eteitai sthn
			  //seiriaka epomenh adeia 0esh tou pinaka.
    for (d=0;d<location;d++) printf(" %2d ",0);
    printf(" %2d ",key);
    for (d=location+1;d<m;d++) printf(" %2d ",0);
    printf("\n");ch=getch();

    count=0;
    do {
      count++;
      location=(location+1) % m;
    } while ((table[location]!=0) && (count<m));
    if (table[location]==0)
      table[location]=key;
     else
      done=0;
   }
 return done;
}

void LinearProbing(void)
{
 int done,i,mine[15]; //Boh0htikos pinakas, opou apo0hkebontai oi tyxaia
		      //paragomenoi arim0oi.

 printf("\n\n");
 n=-1; m=-1;
 while ( ((n>=16) || (n<0)) || ((m>=18) || (m<=n)) )
  { clrscr();
    printf("\nLinear Probing\n\n");
    printf("Dwse n ( 1< n <=15 ) : "); scanf("%d",&n);
    printf("Dwse m ( %d< m <=17 ) : ",n); scanf("%d",&m);
  }//To katw orio gia to m prepei na einai megalytero apo to panw orio
   // tou n giati prepei M>N
 randomize();
 for (i=0;i<n;i++) mine[i]=rand()%99+1;
 for (i=0;i<=m;i++) table[i]=0; //Arxikopoihsh tou pinaka 'table'

 printf("\n\nRandoms:\n");
 for (i=0;i<n;i++) { printf(" %2d ",mine[i]);}
 printf("\nHASH = key MOD m\n");
 ch=getch();
 printf("\n\n          ");
 for (i=0;i<m;i++) { printf(" %2d ",i);}
 printf("\n");
 i=0;
 do {
    done=Linsert(mine[i]);        //Ka0e kleidi mpainei sthn 0esh tou
    printf("%2do BHMA- ",i+1);    //se ka0e bhma, to opoio emfanizetai sthn o0onh
    for (d=0;d<m;d++) printf(" %2d ",table[d]);
    printf("\n");ch=getch();
    i++;
 } while ( (mine[i]!=0) && (i<n));
printf("\n\n Hash Table Done! \n"); //H diadikasia tou Linear Probing
				    //exei oloklhrw0ei kai emfanizetai o
				    //pinakas 'table' me tous ari0mous
				    //meta to hashing
for (d=0;d<m;d++) printf(" %2d ",table[d]);
ch=getch();
}


void DoubleHash(void)
{
    int i,mine[15];//Boh0htikos pinakas, opou apo0hkebontai oi tyxaia
		   //paragomenoi arim0oi.

    printf("\n\n");
    n=-1; m=-1;
    while ( ((n>=16) || (n<0)) || ((m>=18) || (m<=n)) )
     { clrscr();
       printf("\nDouble Hashing\n\n");
       printf("Dwse n ( 1< n <=15 ) : "); scanf("%d",&n);
       printf("Dwse m ( %d< m <=17 ) : ",n); scanf("%d",&m);
     } //To katw orio gia to m prepei na einai megalytero apo to panw orio
       // tou n giati prepei M>N
    randomize();
    for (i=0;i<n;i++) mine[i]=rand()%99+1;//Paragwgh twn tyxaiwn ari0mwn
    for (i=0;i<=m;i++) {table[i]=0; Thash1[i]=0; Thash2[i]=0; }

    printf("\n\nRandoms:\n");
    for (i=0;i<n;i++) { printf(" %2d ",mine[i]);}
    //Emfanish twn tyxaiwn ari0mwn
    ch=getch();
    printf("\nHASH1 = key MOD m\n");
    printf("HASH2 = 8 - (key MOD 8)\n");

    printf("\n\n          ");
    for (i=0;i<m;i++) { printf(" %2d ",i);}
    printf("\n");
    i=0;
    do {
      Dinsert(mine[i]);
      printf("%2do BHMA- ",i+1);
      for (d=0;d<m;d++) printf(" %2d ",table[d]);
      printf("\n");ch=getch();
      i++;
    } while ( (mine[i]!=0) && (i<n));
   printf("\n\n Hash Table Done! \n");//Emfanish ths telikhs morfhs
    printf("    Key   Hash1  Hash2"); //tou pinaka  ka0ws kai twn dyo pinakwn
				      //me tis times tou Hash1 kai Hash2
    for (d=0;d<m;d++)
      if (table[d]!=0)
	{printf("\n   %4d ",table[d]);
	 printf(" %4d ",Thash1[d]);
	 printf("  %4d ",Thash2[d]);
	}
   ch=getch();
}

void main()
{
 int i;
 i=4;
 while ((i<0) || (i>3))
 {
  clrscr();
  printf("----------------\n");  //Kentriko Menu
  printf("      Menu\n");
  printf("1.Linear Probing\n");
  printf("2.Double Hashing\n");
  printf("3.Exit\n\n");
  printf("Choice:");scanf("%d",&i);
   switch (i) {
     case 1: LinearProbing(); i=4; break;
     case 2: DoubleHash(); i=4; break;
     case 3: exit; break;
   }
 }
}